*+
*+
*+    Source Module => NUMGET.PRG
*+
*+    Functions: Function NumGet()
*+
*+    Reformatted by Click! 1.13 on Mar-29-1998 at 10:36 pm
*+
*+

/*
abdou@camnet.cm wrote in message <6da1eu$a9a$1@nnrp1.dejanews.com>...
>I am desperatly trying to modify the behavior of my getsys.prg to input
>numeric values from left to right ( like calcultors do ). The only way i
>succeded to do it is w/o the get system.  I wrote a function to intercept
the
>typing and simulate  get. Can somebody help me to do it in an easier
(smater)
>way? Thanks. Abdourahmani H. Douala - Cameroon

Try this.  You will have to cut out the special garbage that I pass that is
specific to my programme:
*/

#include "INKEY.CH"

*+
*+
*+    Function NumGet()
*+
*+
*+
function NumGet( aField )

local oGet
local nKey
local cNumber
local nInteger
local nDecimal
local lExit       := .f.
local lDecimal    := .f.
local lFirstKey   := .t.

// initialise get object
oGet := GetNew( aField[ 3 ], aField[ 2 ], aField[ 1 ], aField[ 8 ], aField[ 4 ], aField[ 7 ] )

// set other get object variables as necessary
if !empty( aField[ 5 ] )
   oGet:preBlock := aField[ 5 ]
endif

if !empty( aField[ 6 ] )
   oGet:postBlock := aField[ 6 ]
endif

if at( '.', aField[ 4 ] ) == 0
   nDecimal := 0
   nInteger := len( aField[ 4 ] )
else
   nDecimal := len( aField[ 4 ] ) - at( '.', aField[ 4 ] )
   nInteger := len( aField[ 4 ] ) - nDecimal - 1
endif

oGet:setFocus()
oGet:pos := nInteger
oGet:display()

do while !lExit

   nKey := inkey( 0 )

   do case
      // if it is the first key pressed and it numeric, set the buffer to this key
   case lFirstKey .and. ( nKey == 46 .or. ( nKey >= 48 .and. nKey <= 57 ) )

      if nKey == 46                     // decimal
         oGet:buffer := transform( 0, oGet:picture )
         oGet:toDecPos()
         cNumber  := '0'
         lDecimal := .t.
         oGet:display()
      else
         oGet:buffer := transform( val( chr( nKey ) ), oGet:picture )
         cNumber     := chr( nKey )
         oGet:display()
      endif
      lFirstKey    := .f.
      oGet:changed := .t.

      // as this is a numeric get, we react to nKey == 43 ( + ), 45 ( - ), 46 ( . ) and 48 to 57
      // process these keys

   case nKey >= 48 .and. nKey <= 57     // numbers 0 to 9

      if !lDecimal                 // decimal key has not been pressed
         // check if the number would exceed the buffer size ( if the first letter of the buffer is a space - OK )
         if substr( oGet:buffer, 1, 1 ) == ' '
            // add the number to the right
            cNumber      += chr( nKey )
            oGet:buffer  := transform( val( cNumber ), oGet:picture )
            oGet:changed := .t.
            oGet:display()
         else
            if ( set( _SET_BELL ) )
               ?? chr( 7 )
            endif
         endif
      else
         oGet:overStrike( chr( nKey ) )
         oGet:display()
      endif

   case nKey == 45  // minus

      if cNumber == '-'
         cNumber   := '0'
         lFirstKey := .t.
      else
         cNumber   := '-'
         lFirstKey := .f.
      endif

      oGet:buffer  := replicate( ' ', nInteger - 2 ) + '-0.' + replicate( '0', nDecimal )
      oGet:changed := .t.
      oGet:display()

   case nKey == 46  // decimal

      if !lDecimal
         lDecimal := .t.
         cNumber  += chr( nKey )
         oGet:toDecPos()
         oGet:buffer := transform( val( cNumber ), oGet:picture )
         oGet:display()
      else
         if ( set( _SET_BELL ) )
            ?? chr( 7 )
         endif
      endif

      // movement and function keys keys
   case nKey == K_ESC

      if oGet:changed
         oGet:undo()
         oGet:pos := 1
      else
         lExit := .t.
      endif

   case nKey == K_BS
      if cNumber == NIL
         // do nothing

      elseif lDecimal .and. oGet:pos > nInteger + 2
         oGet:delete()
         oGet:pos --

      elseif lDecimal .and. oGet:pos == nInteger + 2
         lDecimal    := .f.
         cNumber     := substr( cNumber, 1, len( cNumber ) - 1 )
         oGet:buffer := transform( val( cNumber ), oGet:picture )
         oGet:pos    := nInteger

      else
         cNumber     := substr( cNumber, 1, len( cNumber ) - 1 )
         oGet:buffer := transform( val( cNumber ), oGet:picture )

      endif

      oGet:display()

   case ascan( aField[ 11 ], nKey ) != 0                    // exit key pressed

      lExit := .t.

   otherwise

      beep( 1 )

   endcase

enddo

if oGet:changed
   oGet:assign()
endif

insert( .f. )

return nKey

*+ EOF: NUMGET.PRG
